//***********************************************************
//*
//* File:           GridPanel.java
//* Author:         Srikant Krishna
//* Contact:        srikant@cs.columbia.edu
//* Update:         9.5.2002
//*
//* Description:    Gridded, sized panel.
//*
//***********************************************************

package ui;

import java.awt.*;
import javax.swing.*;

public final class GridPanel extends JPanel {
    Dimension _dim;
    int       _width;
    int       _height;
    
    public GridPanel(int __width, int __height, int __cols) {         
        _width = __width;
        _height = __height;   
        _dim = new Dimension(_width, _height);
        setLayout(new GridLayout(1, __cols));
        setPreferredSize(_dim);        
    }                    
        
    public Dimension getPreferredSize() {
        return _dim;
    }
        
    public Dimension getMaximumSize() {
        return _dim;
    }
        
    public Dimension getMinimumSize() {
        return _dim;
    }
}
