//***********************************************************
//*
//* File:           IFCConfiguration.java
//* Author:         Srikant Krishna
//* Contact:        srikant@cs.columbia.edu
//* Update:         9.5.2002
//*
//* Description:    Configuration object interface.  Used to
//*                 store, specify, and retrieve
//*                 configuration parameters during
//*                 model instantiation.
//*
//***********************************************************

package ui;

import java.io.Serializable;

public interface IFCConfiguration extends Serializable {

    public void     setNumRounds(int __numrounds)               throws Exception;
    public int      numRounds()                                 throws Exception;
    public void     setNumRoundsBounds(int __min, int __max)    throws Exception;
    public int      numRoundsMin()                              throws Exception;
    public int      numRoundsMax()                              throws Exception;
    public int      numPlayers()                                throws Exception;
    public void     setNumPlayersBounds(int __min, int __max)   throws Exception;
    public int      numPlayersMin()                             throws Exception;
    public int      numPlayersMax()                             throws Exception;
    public void     setNumRobots(int __numrobots)               throws Exception;
    public int      numRobots()                                 throws Exception;
    public int      numRobotsMin()                              throws Exception;
    public int      numRobotsMax()                              throws Exception;
    public void     setSize(int __size)                         throws Exception;
    public int      size()                                      throws Exception;
    public int      sizeMin()                                   throws Exception;
    public int      sizeMax()                                   throws Exception;
    public void     setNumRobotsBounds(int __min, int __max)    throws Exception;
    public void     setSizeBounds(int __min, int __max)         throws Exception;
    public void     setClassList(Class[] __list)                throws Exception;
    public Class[]  classList()                                 throws Exception;
    public Class    getClass(int __pos)                         throws Exception;
    public void     setClass(int __pos, Class __class)          throws Exception;
    public void     setPlayerList(Class[] __list)               throws Exception;
    public Class[]  playerList()                                throws Exception;
    public Class    player(int __pos)                           throws Exception;
    public void     setPlayer(int __pos, Class __class)         throws Exception;
    public String   logFile()                                   throws Exception;
    public void     setLogFile(String __str)                    throws Exception;
}
