//***********************************************************
//*
//* File:           IFCGameRecord.java
//* Author:         Srikant Krishna
//* Contact:        srikant@cs.columbia.edu
//* Update:         9.13.2002
//*
//* Description:    Interface for individual game entries
//*                 used to specify and store tournament
//*                 games.
//*
//***********************************************************

package ui;

import java.io.Serializable;

public interface IFCGameRecord extends Serializable { 

    public void     setPlayers(Class[] __players)               throws Exception;
    public Class[]  players()                                   throws Exception;
    public void     setScores(double[] __scores)                throws Exception;
    public double[] scores()                                    throws Exception;
    public void     setNumRounds(int __numrounds)               throws Exception;
    public int      numRounds()                                 throws Exception;
    public void     setNumRobots(int __numrobots)               throws Exception;
    public int      numRobots()                                 throws Exception;
    public void     setSize(int __size)                         throws Exception;
    public int      size()                                      throws Exception;
    public void     setBatchComplete(boolean __batchcomplete)   throws Exception;
    public boolean  batchComplete()                             throws Exception;
}
