package Rectangles;

import java.awt.Color;
import java.util.*;

public class OldGroup5Player2 implements IFCPlayer {

    static boolean DEBUG = false;

    Rectangles rectangles;
    Robot[] bots;
    Team[] t;
    int myIndex;
    static Random random;
    static {
        try {
            random = java.security.SecureRandom.getInstance("SHA1PRNG");
        } catch (Exception e) {
            System.err.println("eep! Couldn't get a secure RNG");
            random = new Random();
        }
    }

    static final String _CNAME = "Ender's Shadow";
    static final Color  _CCOLOR = new Color(0.5f, 1.0f, 1.0f);
    
    public Robot[] register(Rectangles __rectangles) throws Exception {
        Robot[] RET;
        int _MAX;
        int size;

        rectangles = __rectangles;
	myIndex = rectangles.indexOf(this);

        _MAX = rectangles.numRobots();
        size = rectangles.size();
        RET = new Robot[_MAX];

	t = new Team[2];
	
	int numDest = _MAX / 5;
	Robot[] destructicons = new Robot[numDest];
	t[0] = new Destroyah(destructicons);
	System.arraycopy(destructicons, 0, RET, 0, numDest);

	int numG = _MAX - numDest;
	Robot[] g = new Robot[numG];
	t[1] = new GridTeam(g);
	System.arraycopy(g, 0, RET, numDest, numG);

	return bots = RET;
    }

    public char[] move() throws Exception {
	char[] foo = new char[rectangles.numRobots()];
	int count = 0;
	for(int i=0; i < t.length; i++) {
	    char[] bar = t[i].move();
	    System.arraycopy(bar, 0, foo, count, bar.length);
	    count += bar.length;
	}
	return foo;
    }
    
    public String name() throws Exception {
	return _CNAME;
    }

    public Color color() throws Exception {
	return _CCOLOR;
    }

    public boolean interactive() throws Exception {
	return false;
    }

    public class ChaseBot extends Robot {

	Destroyah owner;

	ChaseBot(int x, int y, Team o) throws Exception {
	    super(x,y);
	    if(! (o instanceof Destroyah)) {
		throw new Exception("ChaseBots must be owned by Destroyahs.");
	    }
	    owner = (Destroyah)o;
	}
	
	char move() throws Exception {
	    
	    //this will be implemented as an internal class.  therefore
	    //we will have full access to rectangles as well as myIndex.
	    
	    Robot[][] allbots = rectangles.allRobots();
	    int other = 1 - myIndex;
	    
	    //for all players which are not ours
	    for(int i = 0; i<rectangles.numPlayers(); i++) {

		if(i == myIndex) continue;
		
		//for all of that player's robots
		for(int j=0; j<rectangles.numRobots(); j++) {
		    
		    if (dist(this, allbots[i][j]) <= 2) {
			
			if (allbots[i][j].xpos() > this.xpos()) {
			    if(owner.follow(i,j))
				return _CEAST;
			}
			else if (allbots[i][j].xpos() < this.xpos()) {
			    if(owner.follow(i,j))
				return _CWEST;
			}
			else if (allbots[i][j].ypos() > this.ypos()) {
			    if(owner.follow(i,j))
				return _CSOUTH;
			}
			else if (allbots[i][j].ypos() < this.ypos()) {
			    if(owner.follow(i,j))
				return _CNORTH;
			}
			else {
			    if(owner.follow(i,j))
				return _CSTAY;
			}
		    }//if distance<=2
		    
		}//for robots
	    }//for players
	    return _CSTAY;
	    
	}
	
	int dist(Robot r1, Robot r2) throws Exception {
	    if (r1 == null || r2 == null)
		throw new Exception ("Who gave me a null robot?");
	    
	    int xdist = r1.xpos() - r2.xpos();
	    if (xdist < 0) xdist = -xdist;
	    int ydist = r1.ypos() - r2.ypos();
	    if (ydist < 0) ydist = -ydist;
	    
	    return xdist + ydist;
	}
	
	
    }

    public abstract class Team {
	
	Robot[] teamBots;
	
	Team(Robot[] r) {
	    teamBots = r;
	}

	Team() {
	    super();
	}
	
	abstract char[] move() throws Exception;
    }

    public class Destroyah extends Team {

	/* array of robots currently being followed: [playerNum][robotNum] */
	boolean[][] following;
		
	Destroyah(Robot[] r) throws Exception{
	    super(r);

	    following = new boolean[rectangles.numPlayers()][rectangles.numRobots()];

	    int s = rectangles.size();
	    for(int i=0; i<teamBots.length; i++) {
		teamBots[i] = new ChaseBot(random.nextInt(s), random.nextInt(s), this);
	    }
	}
		
	char[] move() throws Exception {
	    //clear the list of following
	    for(int i=0; i < following.length; i++) {
		for(int j=0; j < following[i].length; j++) {
		    following[i][j] = false;
		}
	    }
	    
	    char[] foo = new char[teamBots.length];
	    for(int i = 0; i < foo.length; i++) {
		foo[i] = ((ChaseBot) teamBots[i]).move();
	    }
	    return foo;
	}

	boolean follow(int playerNum, int robotNum) {

	    if(following[playerNum][robotNum]) {
		return false;
	    }
	    else{
		return following[playerNum][robotNum] = true;
	    }
	}
    }

    /*GridBot*/
    public class GridBot extends Robot {
	Vertex dest;
	public char inertia;
	boolean unleashed;
	int board_size;
	int skipped_turns;

	public GridBot(int __xpos, int __ypos) 
	    throws Exception 
	{
	    super (__xpos, __ypos);
	    board_size = rectangles.size();
	    inertia = _CSTAY;
	    unleashed = false;
	    dest = null;
	    skipped_turns = 0;
	}

	public char move(GridTeam owner) throws Exception {
	    int closest = closest();

	    if (closest < 4) {
		skipped_turns++;
      
		if (closest == 3 && skipped_turns < 2)
		    return _CSTAY;
      
		if (closest == 2 && skipped_turns < 4)
		    return _CSTAY;
      
		if (closest == 1 && skipped_turns < 8)
		    return _CSTAY;
      
		if (closest == 0 && skipped_turns < 8)
		    return _CSTAY;
	    }
    
	    skipped_turns = 0;

	    if (crowded() && random.nextInt (2) == 0)
		return _CSTAY;

	    if (unleashed) {
		char dir = wander();
		inertia = dir;
		return dir;
	    }

	    while(true) {
		if (dest == null) {
		    dest = owner.whereNext (_position, this);
		}
      
		int deltaX = dest.xpos() - _position.xpos();
		int deltaY = dest.ypos() - _position.ypos();
      
		int absX = deltaX < 0 ? -deltaX : deltaX;
		int absY = deltaY < 0 ? -deltaY : deltaY;

		if (absX > absY) {
		    if (deltaX > 0) {
			inertia = _CEAST;
			return _CEAST;
		    }
		    else if (deltaX < 0) {
			inertia = _CWEST;
			return _CWEST;
		    }
		} else {
		    if (deltaY > 0) {
			inertia = _CSOUTH;
			return _CSOUTH;
		    }
		    else if (deltaY < 0) {
			inertia = _CNORTH;
			return _CNORTH;
		    } else {
			dest = null;
		    }
		}
	    }
	}

	private boolean crowded () throws Exception {
	    Robot all[][] = rectangles.allRobots();
	    Robot mine[] = all[myIndex];
	    int count = 0;

	    for (int i = 0; i < mine.length; i++) {
		Robot robot = mine[i];
		if (robot.xpos() == this.xpos() && robot.ypos() == this.ypos())
		    count++;
	    }

	    if (count < 1) throw new Exception ("Huh?");

	    return count > 1;
	}

	private int closest () throws Exception {
	    int myX = this.xpos();
	    int myY = this.ypos();

	    Robot all[][] = rectangles.allRobots();
    
	    int closest = 4;

	    for (int player = 0; player < all.length; player++) {
		if (player == myIndex) continue;
		for (int i = 0; i < all[player].length; i++) {
		    Robot robot = all[player][i];
		    int theirX = robot.xpos();
		    int theirY = robot.ypos();
        
		    int deltaX = theirX - myX;
		    int deltaY = theirY - myY;

		    if (deltaX < 0) deltaX = -deltaX;
		    if (deltaY < 0) deltaY = -deltaY;

		    if (deltaX <= 3 && deltaY == 0) 
			if (closest > deltaX)
			    closest = deltaX;

		    if (deltaX == 0 && deltaY <= 3)
			if (closest > deltaY)
			    closest = deltaY;
		}
	    }
	    return closest;
	}

	private char wander() throws Exception {
	    int x = this.xpos();
	    int y = this.ypos();

	    Vector last = new Vector();

	    if (x > 0)              last.add (new Vertex (x - 1, y));
	    if (x < board_size - 1) last.add (new Vertex (x + 1, y));
	    if (y > 0)              last.add (new Vertex (x, y - 1));
	    if (y < board_size - 1) last.add (new Vertex (x, y + 1));

	    Vector current;
    
	    current = eliminateBlack (last);
	    if (current.size() == 1) return pickOne (current);
	    if (current.size() == 0) current = last;
	    last = current;

	    current = eliminateBlue (last);
	    if (current.size() == 1) return pickOne (current);
	    if (current.size() == 0) current = last;
	    last = current;

	    current = eliminateEnemies (last);
	    if (current.size() == 1) return pickOne (current);
	    if (current.size() == 0) current = last;
	    last = current;

	    current = eliminateTurns (last);
	    if (current.size() == 1) return pickOne (current);
	    if (current.size() == 0) current = last;

	    return pickOne (current);
	}

	private Vector eliminateBlack (Vector v) throws Exception {
	    Vector out = new Vector ();
	    int board[][] = rectangles.colors();
	    for (int i = 0; i < v.size(); i++) {
		Vertex ver = (Vertex) v.elementAt (i);
		if (board[ver.xpos()][ver.ypos()] != _CFILLED)
		    out.add (ver);
	    }
	    return out;
	}

	private Vector eliminateBlue (Vector v) throws Exception {
	    Vector out = new Vector ();
	    int board[][] = rectangles.colors();
	    for (int i = 0; i < v.size(); i++) {
		Vertex ver = (Vertex) v.elementAt (i);
		if (board[ver.xpos()][ver.ypos()] != myIndex)
		    out.add (ver);
	    }
	    return out;
	}

	private Vector eliminateEnemies (Vector v) throws Exception {
	    Vector out = new Vector ();
	    int board[][] = rectangles.colors();
	    for (int i = 0; i < v.size(); i++) {
		Vertex ver = (Vertex) v.elementAt (i);
		if (board[ver.xpos()][ver.ypos()] == _CEMPTY ||
		    board[ver.xpos()][ver.ypos()] == _CCONTESTED)
		    out.add (ver);
	    }
	    return out;
	}

	private Vector eliminateTurns (Vector v) throws Exception {
	    Vector out = new Vector ();
	    int board[][] = rectangles.colors();
	    for (int i = 0; i < v.size(); i++) {
		Vertex ver = (Vertex) v.elementAt (i);
		if (getDirection (this._position, ver) == inertia)
		    out.add (ver);
	    }
	    return out;
	}

	private char pickOne (Vector v) throws Exception {
	    Object o = v.elementAt (random.nextInt(v.size()));
	    return getDirection (this._position, (Vertex) o);
	}

	private char getDirection (Vertex here, Vertex there) throws Exception {
	    int hereX = here.xpos();
	    int hereY = here.ypos();
	    int thereX = there.xpos();
	    int thereY = there.ypos();

	    if (hereX < thereX) return _CEAST;
	    if (hereX > thereX) return _CWEST;
	    if (hereY < thereY) return _CSOUTH;
	    if (hereY > thereY) return _CNORTH;

	    throw new Exception ("What?");
	}

    }//GridBot

    /*GridTeam*/
    public class GridTeam extends Team {
  
	//  Rectangles rectangles;

	int num_robots;
	int num_unleashed;
	int board_size;
	int my_last_score;

	int num_segments;

	GridTeam(Robot[] r) throws Exception {
	    super(r);
	
	    my_last_score = 0;
    
	    num_robots = rectangles.numRobots();
	    num_unleashed = 0;
	    board_size = rectangles.size();
   
	    num_segments = 3;
	    if (board_size > 32) num_segments = 5;

	    for (int i = 0; i < teamBots.length; i++) {

		int x = random.nextInt(board_size);
		int y = random.nextInt(board_size);
      
		x = nearestStationCoord (x);
		y = nearestStationCoord (y);

		teamBots[i] = new GridBot (x, y);
	    }

	    double total_robots = num_robots * rectangles.numPlayers();
	    double square_size = board_size * board_size;

	    if (square_size / total_robots < 40.0 ||
		board_size <= 10 || 
		board_size <= num_robots) {
		for (int i = 0; i < teamBots.length; i++)
		    ((GridBot)teamBots[i]).unleashed = true;
		num_unleashed = teamBots.length;
	    }
    
	}
  
	public char[] move() throws Exception {

	    char move[] = new char[teamBots.length];
    
	    double seg_per = brokenSegmentRatio();    
	    int num_to_unleash = numToUnleash (seg_per);
    
	    // System.err.println (seg_per * 100 + "%, #" + num_to_unleash);

	    while (num_unleashed < num_to_unleash) {
		GridBot robot = (GridBot)teamBots[random.nextInt (num_robots)];
		if (robot.unleashed == false) {
		    robot.unleashed = true;
		    num_unleashed++;
		}
	    }

	    for (int i = 0; i < teamBots.length; i++)
		move[i] = ((GridBot)teamBots[i]).move(this);   
    
	    return move;
	}

	public Vertex whereNext (Vertex where_now, GridBot robot) throws Exception {
	    if ( ! isStation (where_now)) {
		return nearestStation (where_now);
	    }
      
	    Vertex stations[] = nearbyStations (where_now);
	    return bestStation (where_now, stations, robot);
	}

	private boolean isStation (Vertex v) throws Exception {
	    if ( ! isStationCoord (v.xpos())) 
		return false;

	    if ( ! isStationCoord (v.ypos())) 
		return false;
    
	    return true;
	}

	private boolean isStationCoord (int c) throws Exception {
	    for (int i = 0; i <= num_segments; i++) {
		if (c == i * (board_size - 1) / num_segments)
		    return true;
	    }
	    return false;     
	}
  
	private Vertex nearestStation (Vertex v) throws Exception {
	    int x = nearestStationCoord(v.xpos());
	    int y = nearestStationCoord(v.ypos());
	    return new Vertex (x, y);
	}

	private int nearestStationCoord (int c) throws Exception {
	    if (isStationCoord (c)) return c;

	    int before = 0;
	    int after = board_size - 1;
	    for (int i = 0; i <= num_segments; i++) {
		if (c > i * (board_size - 1) / num_segments) {
		    before = i * (board_size - 1) / num_segments;
		} else if (c < i * (board_size - 1) / num_segments) {
		    after = i * (board_size - 1) / num_segments;
		    break;
		} else {
		    throw new Exception ("What?");
		}
	    }

	    if (c - before > after - c) {
		return before;
	    } else {
		return after;
	    }
	}

	private Vertex[] nearbyStations (Vertex v) throws Exception {

	    if ( ! isStation(v)) {
		throw new Exception ("Not a station");
	    }

	    Vector vec = new Vector();

	    int x = v.xpos();
	    int y = v.ypos();

	    int last_x;
	    int last_y;
	    int next_x;
	    int next_y;

	    if (x == 0) {
		last_x = -1;
	    } else {
		for (last_x = x - 1; ! isStationCoord (last_x); last_x--);
	    }

	    if (y == 0) {
		last_y = -1;
	    } else {
		for (last_y = y - 1; ! isStationCoord (last_y); last_y--);
	    }

	    if (x == board_size - 1) {
		next_x = -1;
	    } else {
		for (next_x = x + 1; ! isStationCoord (next_x); next_x++);
	    }

	    if (y == board_size - 1) {
		next_y = -1;
	    } else {
		for (next_y = y + 1; ! isStationCoord (next_y); next_y++);
	    }

	    if (last_x > -1) vec.add (new Vertex (last_x, y));
	    if (next_x > -1) vec.add (new Vertex (next_x, y));
	    if (last_y > -1) vec.add (new Vertex (x, last_y));
	    if (next_y > -1) vec.add (new Vertex (x, next_y));
    
	    Object o_array[] = vec.toArray();
	    Vertex vertices[] = new Vertex[o_array.length];
	    for (int i = 0; i < o_array.length; i++) {
		vertices[i] = (Vertex) o_array[i];
	    }

	    return vertices;
	}

	private Vertex bestStation (Vertex where_now, Vertex stations[], GridBot robot) 
	    throws Exception 
	{
	    // System.err.println ("Where next from " + where_now + "?");

	    double bestScore;
	    Vector winners;
	    Vector current = new Vector();

	    for (int i = 0; i < stations.length; i++)
		current.add (stations[i]);

	    for (int distance = 1; ; distance++) {
		winners = null;
		bestScore = -65000.0;

		if (distance > num_segments + 2) {
		    throw new Exception ("Clockwise led to a tie???");
		} else if (distance > num_segments + 1) {
		    // System.err.println ("Scores for clockwise");
		} else {
		    // System.err.println ("Scores for distance " + distance);
		}

		for (int i = 0; i < current.size() ; i++) {
		    Vertex station = (Vertex) current.elementAt(i);
		    char direction = getDirection (where_now, station);
		    double score;

		    if (distance > num_segments + 1) {
			score = clockwise (where_now, direction);
		    } else {
			score = score (where_now, direction, distance, robot.inertia);
		    }
		    if (winners == null || score > bestScore) {
			bestScore = score;
			winners = new Vector();
			winners.add (stations[i]);
		    } else if (score == bestScore) {
			winners.add (stations[i]);
		    }
		    // System.err.println (stations[i] + ": " + score);
		}               

		if (winners == null) throw new Exception ("Huh?");
		if (winners.size() == 0) throw new Exception ("What?");
		if (winners.size() == 1) break;

		// System.err.println ("Tie! Time for a runoff.");

		current = winners;
	    }

	    //System.err.println ("Best score: " + bestScore);

	    Vertex v = (Vertex) winners.elementAt(0);
	    // System.err.println ("We're going with " + v);
	    // System.err.println ();

	    return v;
	}

	private char getDirection (Vertex here, Vertex there) throws Exception {
	    int hereX = here.xpos();
	    int hereY = here.ypos();
	    int thereX = there.xpos();
	    int thereY = there.ypos();

	    if (hereX < thereX) return _CEAST;
	    if (hereX > thereX) return _CWEST;
	    if (hereY < thereY) return _CSOUTH;
	    if (hereY > thereY) return _CNORTH;

	    throw new Exception ("What?");
	}

	private double score (Vertex here, char direction, int distance, char inertia)
	    throws Exception
	{
	    int points[] = points (here, direction, distance);

	    boolean kicker = false;
	    boolean rivals = false;
	    boolean whites = false;
	    boolean filled = false;
	    boolean others = false;

	    for (int i = 1; i < points.length; i++) {
		if (points[i] == -10 /* crowded */) {
		    others = true;
		} else if (points[i] == _CFILLED) {
		    filled = true;
		} else if (points[i] == myIndex) {
		    if (i == points.length - 1) 
			kicker = true;
		} else if (points[i] == _CEMPTY) {
		    whites = true;
		} else if (points[i] == _CCONTESTED) {
		    whites = true;
		} else {
		    rivals = true;
		}
	    }

	    double score = 0.0;

	    if (kicker) score +=  1.0;
	    if (rivals) score +=  2.0;
	    if (inertia == direction) score += 4.0;
	    if (whites) score +=  8.0;
	    if (others) score -= 16.0;
	    if (filled) score -= 32.0;

	    return score;
	}

	private double clockwise (Vertex here, char direction) throws Exception {
	    int x = here.xpos();
	    int y = here.ypos();

	    int midpoint = board_size / 2;

	    if (x < midpoint && y < midpoint && direction == _CEAST) return 3.0;
	    if (x < midpoint && y < midpoint && direction == _CNORTH) return 2.0;
	    if (x < midpoint && y < midpoint && direction == _CWEST) return 1.0;
	    if (x < midpoint && y < midpoint && direction == _CSOUTH) return 0.0;

	    if (x >= midpoint && y < midpoint && direction == _CSOUTH) return 3.0;
	    if (x >= midpoint && y < midpoint && direction == _CEAST) return 2.0;
	    if (x >= midpoint && y < midpoint && direction == _CNORTH) return 1.0;
	    if (x >= midpoint && y < midpoint && direction == _CWEST) return 0.0;

	    if (x >= midpoint && y >= midpoint && direction == _CWEST) return 3.0;
	    if (x >= midpoint && y >= midpoint && direction == _CSOUTH) return 2.0;
	    if (x >= midpoint && y >= midpoint && direction == _CEAST) return 1.0;
	    if (x >= midpoint && y >= midpoint && direction == _CNORTH) return 0.0;

	    if (x < midpoint && y >= midpoint && direction == _CNORTH) return 3.0;
	    if (x < midpoint && y >= midpoint && direction == _CWEST) return 2.0;
	    if (x < midpoint && y >= midpoint && direction == _CSOUTH) return 1.0;
	    if (x < midpoint && y >= midpoint && direction == _CEAST) return 0.0;

	    throw new Exception ("Guh?");
	}

	private int[] points (Vertex here, char direction, int distance)
	    throws Exception 
	{
	    int x = here.xpos();
	    int y = here.ypos();
	    int board[][] = rectangles.colors();
	    Vector v = new Vector();
	    int stations_seen = 0;

	    while (true) {
		if (isStation (new Vertex (x, y))) stations_seen++;

		if (crowded (new Vertex (x, y))) {
		    v.add (new Integer (-10));
		} else {
		    v.add (new Integer(board[x][y]));
		}

		if (stations_seen > distance) break;

		if (direction == _CEAST) x++;
		if (direction == _CWEST) x--;
		if (direction == _CSOUTH) y++;
		if (direction == _CNORTH) y--;

		if (x < 0) break;
		if (x > board_size - 1) break;
		if (y < 0) break;
		if (y > board_size - 1) break;
	    }

	    Object o_array[] = v.toArray();
	    int points[] = new int[o_array.length];
	    for (int i = 0; i < o_array.length; i++) {
		points[i] = ((Integer)(o_array[i])).intValue();
	    }

	    return points;
	}
  
	private int getScore () throws Exception {
	    MoveResult history[] = rectangles.history();
	    if (history.length == 0) return 0;
	    MoveResult lastResult = history[history.length - 1];
	    double scores[] = lastResult.scores();
	    return (int) scores[myIndex];
	}

	private boolean crowded (Vertex v) throws Exception {
	    Robot all[][] = rectangles.allRobots();
	    Robot mine[] = all[myIndex];

	    for (int i = 0; i < mine.length; i++) {
		Robot robot = mine[i];
		if (robot.xpos() == v.xpos() && robot.ypos() == v.ypos()) return true;
	    }

	    return false;
	}

	private double brokenSegmentRatio () throws Exception {
	    double good = 0.0;
	    double bad = 0.0;

	    for (int y = 1; y < num_segments; y++)
		for (int x = 0; x < num_segments; x++)
		    if (noBlack (station(x), station(y), true))
			good += 1.0;
		    else
			bad += 1.0;

	    for (int x = 1; x < num_segments; x++)
		for (int y = 0; y < num_segments; y++)
		    if (noBlack (station(x), station(y), false))
			good += 1.0;
		    else
			bad += 1.0;
    
	    //System.err.print ("good: " + good + ", bad: " + bad + ", ");
	    return bad / (good + bad);
	}

	private int station (int c) throws Exception {
	    int stations_seen = -1;

	    for (int i = 0; i < board_size; i++) {
		if (isStationCoord(i))
		    stations_seen++;

		if (stations_seen == c)
		    return i;
	    }
    
	    throw new Exception ("station overflow");
	}

	private boolean noBlack (int x, int y, boolean right) throws Exception {    
	    int board[][] = rectangles.colors();

	    if (board[x][y] == _CFILLED) return false;

	    if (right) x++; else y++;

	    while (true) {
		if (board[x][y] == _CFILLED) return false;
		if (right) {
		    if (isStationCoord (x++)) return true;
		} else {
		    if (isStationCoord (y++)) return true;
		}
	    }
	}

	private int numToUnleash (double seg_per) throws Exception {
	    int numBots = teamBots.length;

	    if (seg_per < 0.25)
		return 0;
      
	    if (seg_per >= 0.75)
		return numBots;

	    if (numBots == 1) return 0;    
	    if (numBots == 2) return 1;

	    double stretched = (seg_per - 0.25) * 2.0;

	    if (stretched < 0.0) throw new Exception ("underflow");
	    if (stretched > 1.0) throw new Exception ("overflow");

	    return 1 + (int)(stretched * numBots);
	}  
    }//GridTeam

}
