//***********************************************************
//*
//* File:           Group8Player3.java
//* Author:         Abhinav Kamra
//* Contact:        kamra@cs.columbia.edu
//* Update:         10.27.2002
//*
//* Description:    Men on Mission
//*
//***********************************************************

package Rectangles;

import ui.*;
import java.util.*;
import java.io.*;
import java.awt.*;

public final class OldGroup8Player3 implements IFCPlayer {


    class Cell // A Cell on the board
    {
	int x;
	int y;

	Cell(int X, int Y)
	{
	    x = X;
	    y = Y;
	}
	int Color()
	{
	    return Grid[x][y];
	}
	int Distance(Cell b)
	{
	    return (Math.abs(b.x - x) + Math.abs(b.y - y));
	}
    }


    class Black_Rect
    {
	int x,y;
	int w,h;

	Black_Rect(int p, int q)
	{
	    x = p;
	    y = q;
	    w = h = 1;
	}

	void Include(int p, int q)
	{
	    if(p < x)
		{
		    w += x-p;
		    x = p;
		}
	    else if(p > x+w-1)
		{
		    w += p-(x+w-1);
		}

	    if(q < y)
		{
		    h += y-q;
		    y = q;
		}
	    else if(q > y+h-1)
		{
		    h += q-(y+h-1);
		}
	}
    }

    class MyRectangle
    {
	int x,y;
	int width,height;
	float ratio;

	MyRectangle(int X, int Y, int w, int h)
	{
	    x = X;
	    y = Y;
	    width = w;
	    height = h;
	}

	float GetRatio()
	{
	    return ratio;
	}

	void SetRatio(float r)
	{
	    ratio = r;
	}

	float FindRatio(int size, int X, int Y)
	{
	    int nonPink = 0;
	    int nonBlack=0;
	    if(X < x)
		nonPink += x-X;
	    if(X > x+width-1)
		nonPink += X-(x+width-1);
	    if(Y < y)
		nonPink += y-Y;
	    if(Y > y+height-1)
		nonPink += Y-(y+height-1);

	    nonPink += size;

	    for(int i=x+1;i<x+width-1;i++)
		for(int j=y+1;j<y+height-1;j++)
		    {
			if(Grid[i][j] != FILLED)
			    nonBlack++;
		    }
	    if(nonBlack > 0)
		return nonBlack/nonPink;
	    else
		return 0;
	}

	ArrayList GiveList()
	{
	    ArrayList a = new ArrayList();
	    int xstart = x;
	    int ystart = y;

	    for(int dx=0;dx < width - 1;dx++)
		    a.add(new Cell(xstart+dx, ystart));

	    xstart = x+width-1;
	    for(int dy=0;dy < height - 1;dy++)
		    a.add(new Cell(xstart, ystart+dy));

	    ystart = y+height-1;
	    for(int dx=0;dx < width - 1;dx++)
		    a.add(new Cell(xstart-dx, ystart));

	    xstart = x;
	    for(int dy=0;dy < height - 1;dy++)
		    a.add(new Cell(xstart, ystart-dy));

	    return a;
	}
	
	ArrayList GiveUnColoredList()
	{
	    ArrayList a = new ArrayList();
	    int xstart = x;
	    int ystart = y;
	    
	    for(int dx=0;dx < width - 1;dx++)
		{
		    if(Grid[xstart+dx][ystart] == FILLED)
			return null;
		    if(Grid[xstart+dx][ystart] != myIndex)
			a.add(new Cell(xstart+dx, ystart));
		}

	    xstart = x+width-1;
	    for(int dy=0;dy < height - 1;dy++)
		{
		    if(Grid[xstart][ystart+dy] == FILLED)
			return null;
		    if(Grid[xstart][ystart+dy] != myIndex)
			a.add(new Cell(xstart, ystart+dy));
		}

	    ystart = y+height-1;
	    for(int dx=0;dx < width - 1;dx++)
		{
		    if(Grid[xstart-dx][ystart] == FILLED)
			return null;
		    if(Grid[xstart-dx][ystart] != myIndex)
			a.add(new Cell(xstart-dx, ystart));
		}

	    xstart = x;
	    for(int dy=0;dy < height - 1;dy++)
		{
		    if(Grid[xstart][ystart-dy] == FILLED)
			return null;
		    if(Grid[xstart][ystart-dy] != myIndex)
			a.add(new Cell(xstart, ystart-dy));
		}

	    return a;
	}

	int UnColoredSize()
	{
	    ArrayList a = GiveUnColoredList();
	    return (a == null)?(0):(a.size());
	}
	String print()
	{
	    Rectangle rect = new Rectangle(x, y, width, height);
	    return rect.toString();
	}
    }


    void ASSERT(boolean b)
    {
	if(!b)
	    {
		while(true)
		    {
			System.out.println("ASSERT FAILED");
		    }
	    }
    }

    // Declarations of Variables....

    Rectangles _rect;
    static Random _random;
    static final String _CNAME = "Men on Mission";
    static final Color  _CCOLOR = new Color(1.0f, 0.67f, 0.67f);

    int N; // Board Size
    int P; // Number of Players
    int B; // Number of Robots per Player
    int myIndex; // My Index in the History and index of my Color


    static final int RectangleBuilder = 1;
    static final int Destructive = 2;

    static final int BLANK = -1;
    static final int FILLED = -2;
    static final int INVALID = -3;
    int[][] Grid;

    Robot[][] allRobotPositions;
    int[] RobotTeam; // RobotTeam[i] gives the team number to which Robot i belongs
    // or -1 if the Robot is currently free.

    int MAX_TRIES;
    Team[] teams;

    // End.. Declaration of Variables....

    MyRectangle best_rect;


    public Robot[] register(Rectangles __rectangles) throws Exception {
        Robot[] RET;
        int _MAX;
        int size;

        _rect = __rectangles;
        if (_random  == null) {
            _random = new Random();
        }

	// Initialize
        N = _rect.size();
        P = _rect.numPlayers();
        B = _rect.numRobots();
	MAX_TRIES = (B > 40)?(B):(40);
	myIndex = _rect.indexOf(this);
	teams = new Team[B];
	RobotTeam = new int[B];
	for(int i=0;i<B;i++)
	    RobotTeam[i] = -1;

	//	Blacks = new Black_Rect[N*N];

	Grid = new int[N][N];
	for(int i=0;i<N;i++)
	    {
		for(int j=0;j<N;j++)
		    Grid[i][j] = BLANK;
	    }

        RET = new Robot[B];
        for (int i=0; i < B; i++) {
            RET[i] = new Robot(_random.nextInt(N), _random.nextInt(N));
        }
        return RET;
    }

    /*
    void UpdateBlacks()
    {
	int[][] NewGrid = new int[N][N];
	for(int i=0;i<N;i++)
	    for(int j=0;j<N;j++)
		{
		    NewGrid[i][j] = (Grid[i][j] == FILLED)?(FILLED):(BLANK);
		}

	for(int i=0;i<B;i++)
	    {
		if((teams[i] != null)&&(teams[i].valid)&&(teams[i].type == RectangleBuilder))
		    {
			MyRectangle rect = teams[i].GiveRect();
			for(int p=rect.x+1;p<rect.x+rect.width-2;p++)
			    for(int q=rect.y+1;q<rect.y+rect.height-2;q++)
				NewGrid[p][q] = FILLED;
		    }
	    }
	black_boxes = 0;
	for(int i=0;i<N;i++)
	    for(int j=0;j<N;j++)
		{
		    if(i != 0) // Look up
			{
			    if(NewGrid[i-1][j] >= 0)
				{
				    NewGrid[i][j] = NewGrid[i-1][j];
				    Blacks[NewGrid[i][j]].Include(i,j);
				}
			    continue;
			}
		    if(j != 0) // Look left
			{
			    if(NewGrid[i][j-1] >= 0)
				{
				    NewGrid[i][j] = NewGrid[i][j-1];
				    Blacks[NewGrid[i][j]].Include(i,j);
				}
			    continue;
			}
		    if(NewGrid[i][j] == FILLED)
			{
			    Blacks[black_boxes] = new Black_Rect(i,j);
			    NewGrid[i][j] = black_boxes;
			    black_boxes++;
			}
		}
    }
    */

    void UpdateGrid() throws Exception
    {
	allRobotPositions = _rect.allRobots();
	HashMap hash = new HashMap();

	ASSERT(P == allRobotPositions.length);

	// Lets see if some rectangles have been filled...
	boolean[][] black = _rect.filled();
	for(int i=0;i<N;i++)
	    for(int j=0;j<N;j++)
		{
		    if(black[i][j] == true)
			Grid[i][j] = FILLED;
		}

	// Now lets see where the robots have been to..
	for(int i=0;i<P;i++)
	    for(int j=0;j<B;j++)
		{
		    // Robot of color i at position x,y
		    int x = allRobotPositions[i][j].xpos();
		    int y = allRobotPositions[i][j].ypos();

		    // If already Black then forget it..
		    if(Grid[x][y] == FILLED)
			continue;

		    Integer key = new Integer(x*N + y);
		    Integer prevColor = (Integer)hash.get(key);
		    Integer newColor = new Integer(i);
		    if(prevColor == null)
			{
			    hash.put(key, newColor);
			    Grid[x][y] = i;
			}
		    else
			{
			    if(prevColor.intValue() != i)
				{
				    Grid[x][y] = BLANK;
				    hash.put(key, new Integer(INVALID));
				}
			}
		}
	// This is the correct grid state...
//	UpdateBlacks();
    }


    Cell GetRobotPosition(int robot_index) throws Exception
    {
	int x = allRobotPositions[myIndex][robot_index].xpos();
	int y = allRobotPositions[myIndex][robot_index].ypos();
	return new Cell(x,y);
    }

    void FreeRobot(int robot_index)
    {
	RobotTeam[robot_index] = -1;
    }

    void RenewTeams()
    {
	for(int i=0;i<B;i++)
	    {
		if((teams[i] != null) && teams[i].valid)
		    {
			teams[i].Renew();
		    }
	    }
    }

    void UpdateBestRect(MyRectangle newrect, int size, int x, int y)
    {
	float ratio = newrect.FindRatio(size, x,y);
	if((best_rect == null)||(ratio > best_rect.GetRatio()))
	    {
		best_rect = newrect;
		best_rect.SetRatio(ratio);
	    }
    }

    void CreateNewTeamForRobot(int robot_index) throws Exception
    {
	int x,y,w,h;
	MyRectangle rect;
	int tries = 0;
	boolean success = false;
	
	Cell source = GetRobotPosition(robot_index);

	best_rect = null;
	while(true)
	    {
		tries++;

		x = _random.nextInt(N-2);
		y  =_random.nextInt(N-2);

		w = 3 + _random.nextInt(N-x-3+1);
		h = 3 + _random.nextInt(N-y-3+1);
		rect = new MyRectangle(x, y, w, h);
//		System.out.println("Checking Rectangle "+rect.print());
		if(tries > MAX_TRIES)
		    break;
		int size = rect.UnColoredSize();
		if(size == 0)
		    continue;
		success = true;
		UpdateBestRect(rect, size, source.x, source.y);
		//		break;
	    }
	int index = 0;
	for(int i=0;i<B;i++)
	    {
		if((teams[i] == null)||(teams[i].valid == false))
		    {
			index = i;
			break;
		    }
	    }
	if(success&&(best_rect != null))
	    teams[index] = new RectangleTeam();
	else
	    teams[index] = new DestructiveRandomWalk();
	teams[index].Init(best_rect);
	if(teams[index].TryAddingRobot(robot_index))
	    RobotTeam[robot_index] = index;
    }

    void AssignRobot(int robot_index) throws Exception
    {
	for(int i=0;i<B;i++)
	    {
		if((teams[i] != null) && teams[i].valid)
		    {
			if(teams[i].TryAddingRobot(robot_index))
			    {
				RobotTeam[robot_index] = i;
				return;
			    }
		    }
	    }
	CreateNewTeamForRobot(robot_index);
    }

    public char[] move() throws Exception {

	UpdateGrid();

	// Recalculate the team constitutions..
	// and free Robots if necessary..
	RenewTeams();

	for(int i=0;i<B*B;i++)
	    {
		int curr_robot = i%B;
//System.out.println(curr_robot+"'s team is ..."+RobotTeam[curr_robot]);
		if(RobotTeam[curr_robot] < 0)
		    AssignRobot(curr_robot); // Assign every free Robot to a team or create a new team if necessary...
//System.out.println(curr_robot+"'s team is now..."+RobotTeam[curr_robot]);
	    }

        char[] RET = new char[B];
        
        for (int i=0; i < B; i++) {
	    // Ask for the nextmove of Robot i from its Team
	    RET[i] = teams[RobotTeam[i]].GetMove(i);
	    // RET[i] = _CDIRECTIONS[_random.nextInt(_CDIRECTIONS.length - 1) + 1];
        }
        return RET;
    }

    public String name() throws Exception {
        return _CNAME;
    }

    public Color color() throws Exception {
        return _CCOLOR;
    }

    public boolean interactive() throws Exception {
        return false;
    }        


    // Declaration of Constituent Classes....

    abstract class Team
    {
	boolean valid;
	int type;

	Team()
	{
	    valid = true;
	}
	abstract void Renew();
	abstract void Init(MyRectangle rect);
	abstract boolean TryAddingRobot(int robot_index) throws Exception;
	abstract char GetMove(int robot_index) throws Exception;
	abstract MyRectangle GiveRect();
	
	char NextMove(int Xoft, int Yoft)
        {
            char move;
            switch(Xoft+Yoft)
                {
                case -1:
                    if(Xoft == 0)
                        move = 'N';
                    else
                        move = 'W';
                    break;
                case 0:
                    move = 'Y';
                    break;
                case 1:
                    if(Xoft == 0)
                        move = 'S';
                    else
                        move = 'E';
                    break;
                default:
                    move = 'Y';
                    break;
                }
            return move;
        }

	int GetColor(int x, int y)
	{
	    return Grid[x][y];
	}
    }
    
    class RectangleTeam extends Team
    {
	MyRectangle myRect;
	ArrayList AllCells;

	int curr_rounds;
	int max_rounds;
	int curr_members;

	class Member
	{
	    boolean valid;
	    int robot_index;
	    int max_time;
	    Cell next_target;

	    Member()
	    {
		valid = false;
	    }
	}

	Member[] members;

	RectangleTeam()
	{
	    curr_rounds = 0;
	    AllCells = new ArrayList();
	    members = new Member[B];
	    type = RectangleBuilder;
	}


	MyRectangle GiveRect()
	{
	    return myRect;
	}

	void Renew()
	{
	    curr_rounds++;
	    AllCells = myRect.GiveUnColoredList();
	    if((curr_rounds > max_rounds)||(AllCells == null)||(AllCells.size() == 0))
		{
		    valid = false;
		    for(int i=0;i<B;i++)
			{
			    if((members[i] != null) && members[i].valid)
				{
				    FreeRobot(members[i].robot_index);
				}
			}
		}
	}

	void Init(MyRectangle newrect)
	{
	    myRect = newrect;
	    AllCells = myRect.GiveUnColoredList();
	    curr_rounds = 0;
	    curr_members = 0;
	    if(AllCells != null)
		max_rounds = 2*AllCells.size();
//	    System.out.println("Targeting Rectangle "+myRect.print());
	}

	int FindMember(int robot_index)
	{
	    for(int i=0;i<B;i++)
		if((members[i] != null) && members[i].valid && (members[i].robot_index == robot_index))
		    return i;
	    return -1;
	}
	int FindNewMember()
	{
	    int free_index = 0;
	    for(int i=0;i<B;i++)
		if((members[i] == null)||(members[i].valid == false))
		    {
			members[i] = new Member();
			free_index = i;
			break;
		    }
	    return free_index;
	}


	int GetDistance(int robot_index) throws Exception
	{
	    Cell source = GetRobotPosition(robot_index);
	    int min_dist = 3*N;
	    int size = (AllCells != null)?(AllCells.size()):(0);
	    for(int i=0;i<size;i++)
		{
		    Cell target = (Cell)AllCells.get(i);
		    int new_dist = source.Distance(target);
		    if(new_dist < min_dist)
			{
			    min_dist = new_dist;
			}
		}
	    return min_dist;
	}

	boolean TryAddingRobot(int robot_index) throws Exception
	{
	    if(curr_members != 0)
		{
		    int prev = GetDistance(members[0].robot_index);
		    int next = GetDistance(robot_index);
//		    System.out.println("prev,next = "+prev+", "+next);
		    if(next < prev)
			{
			    FreeRobot(members[0].robot_index);
			    curr_members--;
			    members[0].valid = false;
			}
		    else
			return false;
		}
	    int member_index = FindNewMember();
	    if(member_index < 0)
		System.out.println("Panic: Negative index returned");

	    Cell source = GetRobotPosition(robot_index);

	    members[member_index].valid = true;
	    members[member_index].robot_index = robot_index;
	    members[member_index].next_target = source;

	    curr_members++;
	    max_rounds = GetDistance(members[0].robot_index) + 2*((AllCells != null)?(AllCells.size()):(0));
	      
	    return true;
	}

	char GetMove(int robot_index) throws Exception
	{
	    Cell source = GetRobotPosition(robot_index);
	    int member_index = FindMember(robot_index);

	    members[member_index].next_target = source;

	    int min_dist = 3*N;
	    int size = (AllCells != null)?(AllCells.size()):(0);
	    for(int i=0;i<size;i++)
		{
		    Cell target = (Cell)AllCells.get(i);
		    int new_dist = source.Distance(target);
		    if(new_dist < min_dist)
			{
			    min_dist = new_dist;
			    members[member_index].next_target = target;
			}
		}

	    int xshift = members[member_index].next_target.x - source.x;
	    xshift = (xshift == 0)?(0):(xshift/Math.abs(xshift));
	    int yshift = members[member_index].next_target.y - source.y;
	    yshift = (yshift == 0)?(0):(yshift/Math.abs(yshift));
	    


//	    System.out.println("(size,max,curr) = "+size+" "+max_rounds+" "+curr_rounds+"(xOft,yOft) = "+xshift+" "+yshift);

	    if((xshift != 0)  && (yshift != 0))
		{
		    int xcolor = GetColor(source.x + xshift, source.y);
		    if((xcolor != FILLED)&&(xcolor!= myIndex))
			return NextMove(xshift, 0);
		    else
			return NextMove(0, yshift);
		}
	    else
		return NextMove(xshift, yshift);

	}

    }

    class DestructiveRandomWalk extends Team
    {
	int curr_rounds;
	int max_rounds;
	int robot_index;
	int last_direction;

	int[][] directions;
	// 0 means 0,1 --> move South
	// 1 means 1,0 --> move East
	// 2 means 0,-1 --> move North
	// 3 means -1,0 --> move West

	DestructiveRandomWalk()
	{
	    type = Destructive;
	}

	MyRectangle GiveRect()
	{
	    return null;
	}

	void Init(MyRectangle rect)
	{
	    valid = true;
	    curr_rounds = 0;
	    max_rounds = 10;
	    robot_index = -1;
	    last_direction = _random.nextInt(4);;
	    directions = new int[4][2];

	    directions[0][0] = 0;
	    directions[0][1] = 1;

	    directions[1][0] = 1;
	    directions[1][1] = 0;

	    directions[2][0] = 0;
	    directions[2][1] = -1;

	    directions[3][0] = -1;
	    directions[3][1] = 0;

	}

	void Renew()
	{
	    curr_rounds++;
	    if(curr_rounds > max_rounds)
		{
		    valid = false;
		    FreeRobot(robot_index);
		}
	}
	
	boolean TryAddingRobot(int robot)
	{
	    if(robot_index >= 0)
		return false;
	    robot_index = robot;
	    return true;
	}
	
	void print()
	{
//	    System.out.println("robot_index="+robot_index+": curr_rounds = "+curr_rounds);
	}

	boolean Alright(int x, int y)
	{
	    if((x >= 0)&&(x < N)&&(y >= 0)&&(y < N))
		return true;
	    return false;
	}
	
	boolean Okay(int x, int y)
	{
	    if(Alright(x,y)&&(Grid[x][y] != FILLED)&&(Grid[x][y] != myIndex))
		return true;
	    return false;
	}

	char GetMove(int robot) throws Exception
	{
	    if(robot != robot_index)
		return 'Y';
	    Cell source = GetRobotPosition(robot_index);
	    
	    int x = source.x;
	    int y = source.y;
	    
	    int shiftx = directions[last_direction][0];
	    int shifty = directions[last_direction][1];
	    if(Okay(x + shiftx, y + shifty))
		return NextMove(shiftx, shifty);
	 
	    for(int i=0;i<10;i++)
		{
		    int next_dir = _random.nextInt(4);
		    shiftx = directions[next_dir][0];
		    shifty = directions[next_dir][1];
		    if(Okay(x + shiftx, y + shifty))
			{
			    last_direction = next_dir;
			    return NextMove(shiftx, shifty);
			}
		}

	    shiftx = directions[last_direction][0];
	    shifty = directions[last_direction][1];
	    if(Alright(x + shiftx, y + shifty))
		return NextMove(shiftx, shifty);

	    int[] permute = new int[4];
	    for(int i=0;i<4;i++)
		permute[i] = i;
	    for(int i=0;i<4;i++)
		{
		    int a = _random.nextInt(4);
		    int b = _random.nextInt(4);
		    int tmp = permute[a];
		    permute[a] = permute[b];
		    permute[b] = tmp;
		}
	    for(int i=0;i<4;i++)
		{
		    shiftx = directions[permute[i]][0];
		    shifty = directions[permute[i]][1];
		    if(Alright(x + shiftx, y + shifty))
			{
			    last_direction = permute[i];
			    return NextMove(shiftx, shifty);
			}
		}
	    return 'Y';
	}
    }
    
    // End.. Declaration of Constituent Classes....
}
